(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_kotlinx_datetime) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var protoOf = kotlin_kotlin.$_$.d6;
  var getStringHashCode = kotlin_kotlin.$_$.p5;
  var hashCode = kotlin_kotlin.$_$.q5;
  var THROW_CCE = kotlin_kotlin.$_$.d9;
  var equals = kotlin_kotlin.$_$.k5;
  var classMeta = kotlin_kotlin.$_$.i5;
  var setMetadataFor = kotlin_kotlin.$_$.e6;
  var split = kotlin_kotlin.$_$.e8;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.h;
  var charSequenceLength = kotlin_kotlin.$_$.g5;
  var Unit_instance = kotlin_kotlin.$_$.v1;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.j2;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.g;
  var Companion_getInstance = kotlin_org_jetbrains_kotlinx_kotlinx_datetime.$_$.a;
  var joinToString = kotlin_kotlin.$_$.f3;
  var startsWith = kotlin_kotlin.$_$.f8;
  var listOf = kotlin_kotlin.$_$.r3;
  var emptyList = kotlin_kotlin.$_$.t2;
  var listOf_0 = kotlin_kotlin.$_$.q3;
  var plus = kotlin_kotlin.$_$.z3;
  var isBlank = kotlin_kotlin.$_$.n7;
  var toInt = kotlin_kotlin.$_$.l8;
  var Companion_instance = kotlin_kotlin.$_$.u1;
  var isCharSequence = kotlin_kotlin.$_$.t5;
  var trim = kotlin_kotlin.$_$.q8;
  var toString = kotlin_kotlin.$_$.g6;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.m1;
  var createFailure = kotlin_kotlin.$_$.g9;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.p1;
  var _Result___get_isFailure__impl__jpiriv = kotlin_kotlin.$_$.n1;
  var getBooleanHashCode = kotlin_kotlin.$_$.m5;
  var first = kotlin_kotlin.$_$.y2;
  var copyToArray = kotlin_kotlin.$_$.p2;
  var to = kotlin_kotlin.$_$.m9;
  var json = kotlin_kotlin.$_$.v5;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CommitRef, 'CommitRef', classMeta);
  setMetadataFor(GitAdapter, 'GitAdapter', classMeta);
  setMetadataFor(GitStatus, 'GitStatus', classMeta);
  //endregion
  function CommitRef(id, authorEmail, committerEmail, dateTime, parents, fullMessage) {
    this.bt_1 = id;
    this.ct_1 = authorEmail;
    this.dt_1 = committerEmail;
    this.et_1 = dateTime;
    this.ft_1 = parents;
    this.gt_1 = fullMessage;
  }
  protoOf(CommitRef).toString = function () {
    return 'CommitRef(id=' + this.bt_1 + ', authorEmail=' + this.ct_1 + ', committerEmail=' + this.dt_1 + ', dateTime=' + this.et_1 + ', parents=' + this.ft_1 + ', fullMessage=' + this.gt_1 + ')';
  };
  protoOf(CommitRef).hashCode = function () {
    var result = getStringHashCode(this.bt_1);
    result = imul(result, 31) + getStringHashCode(this.ct_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.dt_1) | 0;
    result = imul(result, 31) + this.et_1.hashCode() | 0;
    result = imul(result, 31) + hashCode(this.ft_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.gt_1) | 0;
    return result;
  };
  protoOf(CommitRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof CommitRef))
      return false;
    var tmp0_other_with_cast = other instanceof CommitRef ? other : THROW_CCE();
    if (!(this.bt_1 === tmp0_other_with_cast.bt_1))
      return false;
    if (!(this.ct_1 === tmp0_other_with_cast.ct_1))
      return false;
    if (!(this.dt_1 === tmp0_other_with_cast.dt_1))
      return false;
    if (!this.et_1.equals(tmp0_other_with_cast.et_1))
      return false;
    if (!equals(this.ft_1, tmp0_other_with_cast.ft_1))
      return false;
    if (!(this.gt_1 === tmp0_other_with_cast.gt_1))
      return false;
    return true;
  };
  function parseLog($this, outputText) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.filter' call
    // Inline function 'kotlin.collections.filterTo' call
    var this_0 = split(outputText, [$this.it_1 + '\n']);
    var destination = ArrayList_init_$Create$();
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var element = tmp0_iterator.u();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      // Inline function 'kotlin.text.isNotEmpty' call
      if (charSequenceLength(element) > 0) {
        destination.o(element);
      }
    }
    // Inline function 'kotlin.collections.mapTo' call
    var destination_0 = ArrayList_init_$Create$_0(collectionSizeOrDefault(destination, 10));
    var tmp0_iterator_0 = destination.r();
    while (tmp0_iterator_0.s()) {
      var item = tmp0_iterator_0.u();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      var elements = split(item, ['\n']);
      var tmp = elements.c1(0);
      var tmp_0 = elements.c1(1);
      var tmp_1 = elements.c1(2);
      var tmp_2 = Companion_getInstance().ss(elements.c1(3));
      // Inline function 'kotlin.collections.filter' call
      // Inline function 'kotlin.collections.filterTo' call
      var this_1 = split(elements.c1(4), [' ']);
      var destination_1 = ArrayList_init_$Create$();
      var tmp0_iterator_1 = this_1.r();
      while (tmp0_iterator_1.s()) {
        var element_0 = tmp0_iterator_1.u();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.isNotEmpty' call
        if (charSequenceLength(element_0) > 0) {
          destination_1.o(element_0);
        }
      }
      var tmp$ret$8 = new CommitRef(tmp, tmp_0, tmp_1, tmp_2, destination_1, joinToString(elements.z1(5, elements.l()), '\n'));
      destination_0.o(tmp$ret$8);
    }
    return destination_0;
  }
  function findByPrefix(_this__u8e3s4, $this, prefix) {
    // Inline function 'kotlin.collections.find' call
    var tmp$ret$1;
    $l$block: {
      // Inline function 'kotlin.collections.firstOrNull' call
      var tmp0_iterator = _this__u8e3s4.r();
      while (tmp0_iterator.s()) {
        var element = tmp0_iterator.u();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.findByPrefix.<anonymous>' call
        if (startsWith(element, prefix)) {
          tmp$ret$1 = element;
          break $l$block;
        }
      }
      tmp$ret$1 = null;
    }
    var tmp0_safe_receiver = tmp$ret$1;
    var tmp;
    if (tmp0_safe_receiver == null) {
      tmp = null;
    } else {
      // Inline function 'kotlin.text.substring' call
      var startIndex = prefix.length;
      // Inline function 'kotlin.js.asDynamic' call
      tmp = tmp0_safe_receiver.substring(startIndex);
    }
    return tmp;
  }
  function GitAdapter(workingDirectory) {
    this.ht_1 = workingDirectory;
    this.it_1 = '--------!--------';
    this.jt_1 = '%H%n%ae%n%ce%n%aI%n%P%n%B%n' + this.it_1;
  }
  protoOf(GitAdapter).kt = function (name, ref) {
    runProcess(listOf(['git', 'tag', '--annotate', '--message=' + name, name, ref]), this.ht_1);
  };
  protoOf(GitAdapter).lt = function () {
    runProcess(listOf(['git', 'push', '--tags']), this.ht_1);
  };
  protoOf(GitAdapter).mt = function (ref) {
    return findByPrefix(split(runProcess(listOf(['git', 'show', ref, '--format=%D', '--no-patch']), this.ht_1), [', ']), this, 'tag: ');
  };
  protoOf(GitAdapter).nt = function (begin, end) {
    return parseLog(this, runProcess(plus(listOf(['git', '--no-pager', 'log', '--format=' + this.jt_1, begin]), !(end == null) ? listOf_0(end) : emptyList()), this.ht_1));
  };
  protoOf(GitAdapter).ot = function () {
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.status.<anonymous>' call
    var output = runProcess(listOf(['git', 'status', '--porcelain=2', '--branch', '--ahead-behind']), this.ht_1);
    var lines = split(output, ['\n']);
    var head = findByPrefix(lines, this, '# branch.head ');
    var upstream = findByPrefix(lines, this, '# branch.upstream ');
    var tmp0_safe_receiver = findByPrefix(lines, this, '# branch.ab ');
    var tmp1_safe_receiver = tmp0_safe_receiver == null ? null : split(tmp0_safe_receiver, [' ']);
    var tmp;
    if (tmp1_safe_receiver == null) {
      tmp = null;
    } else {
      // Inline function 'kotlin.collections.map' call
      // Inline function 'kotlin.collections.mapTo' call
      var destination = ArrayList_init_$Create$_0(collectionSizeOrDefault(tmp1_safe_receiver, 10));
      var tmp0_iterator = tmp1_safe_receiver.r();
      while (tmp0_iterator.s()) {
        var item = tmp0_iterator.u();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.status.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.substring' call
        // Inline function 'kotlin.js.asDynamic' call
        var tmp$ret$2 = item.substring(1);
        destination.o(tmp$ret$2);
      }
      tmp = destination;
    }
    var tmp2_elvis_lhs = tmp;
    var tmp3_container = tmp2_elvis_lhs == null ? listOf(['-1', '-1']) : tmp2_elvis_lhs;
    // Inline function 'kotlin.collections.component1' call
    var a = tmp3_container.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var b = tmp3_container.c1(1);
    // Inline function 'kotlin.collections.filterNot' call
    // Inline function 'kotlin.collections.filterNot' call
    // Inline function 'kotlin.collections.filterNotTo' call
    var destination_0 = ArrayList_init_$Create$();
    var tmp0_iterator_0 = lines.r();
    while (tmp0_iterator_0.s()) {
      var element = tmp0_iterator_0.u();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.status.<anonymous>.<anonymous>' call
      if (!startsWith(element, '#')) {
        destination_0.o(element);
      }
    }
    // Inline function 'kotlin.collections.filterNotTo' call
    var destination_1 = ArrayList_init_$Create$();
    var tmp0_iterator_1 = destination_0.r();
    while (tmp0_iterator_1.s()) {
      var element_0 = tmp0_iterator_1.u();
      if (!isBlank(element_0)) {
        destination_1.o(element_0);
      }
    }
    var tmp_0 = destination_1.y();
    var tmp_1 = toInt(a);
    var tmp_2 = toInt(b);
    var tmp_3 = head == null ? '' : head;
    return new GitStatus(tmp_0, tmp_1, tmp_2, tmp_3, upstream == null ? '' : upstream);
  };
  protoOf(GitAdapter).pt = function (abbrev) {
    // Inline function 'kotlin.Result.getOrNull' call
    // Inline function 'kotlin.runCatching' call
    var tmp;
    try {
      // Inline function 'kotlin.Companion.success' call
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.describe.<anonymous>' call
      // Inline function 'kotlin.text.trim' call
      var this_0 = runProcess(listOf(['git', 'describe', '--abbrev=' + abbrev]), this.ht_1);
      var value = toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
      tmp = _Result___init__impl__xyqfz8(value);
    } catch ($p) {
      var tmp_0;
      if ($p instanceof Error) {
        var e = $p;
        // Inline function 'kotlin.Companion.failure' call
        tmp_0 = _Result___init__impl__xyqfz8(createFailure(e));
      } else {
        throw $p;
      }
      tmp = tmp_0;
    }
    var this_1 = tmp;
    var tmp_1;
    if (_Result___get_isFailure__impl__jpiriv(this_1)) {
      tmp_1 = null;
    } else {
      var tmp_2 = _Result___get_value__impl__bjfvqg(this_1);
      tmp_1 = (tmp_2 == null ? true : !(tmp_2 == null)) ? tmp_2 : THROW_CCE();
    }
    return tmp_1;
  };
  function GitStatus(isClean, ahead, behind, head, upstream) {
    this.qt_1 = isClean;
    this.rt_1 = ahead;
    this.st_1 = behind;
    this.tt_1 = head;
    this.ut_1 = upstream;
  }
  protoOf(GitStatus).toString = function () {
    return 'GitStatus(isClean=' + this.qt_1 + ', ahead=' + this.rt_1 + ', behind=' + this.st_1 + ', head=' + this.tt_1 + ', upstream=' + this.ut_1 + ')';
  };
  protoOf(GitStatus).hashCode = function () {
    var result = getBooleanHashCode(this.qt_1);
    result = imul(result, 31) + this.rt_1 | 0;
    result = imul(result, 31) + this.st_1 | 0;
    result = imul(result, 31) + getStringHashCode(this.tt_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.ut_1) | 0;
    return result;
  };
  protoOf(GitStatus).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GitStatus))
      return false;
    var tmp0_other_with_cast = other instanceof GitStatus ? other : THROW_CCE();
    if (!(this.qt_1 === tmp0_other_with_cast.qt_1))
      return false;
    if (!(this.rt_1 === tmp0_other_with_cast.rt_1))
      return false;
    if (!(this.st_1 === tmp0_other_with_cast.st_1))
      return false;
    if (!(this.tt_1 === tmp0_other_with_cast.tt_1))
      return false;
    if (!(this.ut_1 === tmp0_other_with_cast.ut_1))
      return false;
    return true;
  };
  function get_childProcess() {
    _init_properties_RunProcess_js_kt__6db8dd();
    return childProcess;
  }
  var childProcess;
  function runProcess(args, workingDirectory) {
    _init_properties_RunProcess_js_kt__6db8dd();
    var program = first(args);
    // Inline function 'kotlin.collections.toTypedArray' call
    var this_0 = args.z1(1, args.l());
    var tmp$ret$0 = copyToArray(this_0);
    var spawn = get_childProcess().spawnSync(program, tmp$ret$0, json([to('cwd', workingDirectory), to('maxBuffer', 10485760)]));
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp0_safe_receiver = spawn.stdout;
    return tmp0_safe_receiver == null ? null : tmp0_safe_receiver.toString('utf8');
  }
  var properties_initialized_RunProcess_js_kt_yehn37;
  function _init_properties_RunProcess_js_kt__6db8dd() {
    if (!properties_initialized_RunProcess_js_kt_yehn37) {
      properties_initialized_RunProcess_js_kt_yehn37 = true;
      childProcess = require('node:child_process');
    }
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = GitAdapter;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./Kotlin-DateTime-library-kotlinx-datetime.js')));

//# sourceMappingURL=tools-git-adapter.js.map
