(function (_, kotlin_kotlin, kotlin_com_zegreatrob_tools_digger_core) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var split = kotlin_kotlin.$_$.e8;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.j2;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.g;
  var toInt = kotlin_kotlin.$_$.l8;
  var Unit_instance = kotlin_kotlin.$_$.v1;
  var charSequenceLength = kotlin_kotlin.$_$.g5;
  var charSequenceGet = kotlin_kotlin.$_$.f5;
  var digitToIntOrNull = kotlin_kotlin.$_$.g7;
  var protoOf = kotlin_kotlin.$_$.d6;
  var classMeta = kotlin_kotlin.$_$.i5;
  var setMetadataFor = kotlin_kotlin.$_$.e6;
  var Enum = kotlin_kotlin.$_$.w8;
  var THROW_CCE = kotlin_kotlin.$_$.d9;
  var isCharSequence = kotlin_kotlin.$_$.t5;
  var trim = kotlin_kotlin.$_$.q8;
  var toString = kotlin_kotlin.$_$.g6;
  var Companion_instance = kotlin_kotlin.$_$.u1;
  var get = kotlin_kotlin.$_$.k7;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.m1;
  var createFailure = kotlin_kotlin.$_$.g9;
  var _Result___get_isFailure__impl__jpiriv = kotlin_kotlin.$_$.n1;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.p1;
  var substringBefore = kotlin_kotlin.$_$.i8;
  var contains = kotlin_kotlin.$_$.e7;
  var to = kotlin_kotlin.$_$.m9;
  var mapOf = kotlin_kotlin.$_$.t3;
  var LinkedHashMap_init_$Create$ = kotlin_kotlin.$_$.k;
  var joinToString = kotlin_kotlin.$_$.f3;
  var objectMeta = kotlin_kotlin.$_$.c6;
  var getStringHashCode = kotlin_kotlin.$_$.p5;
  var hashCode = kotlin_kotlin.$_$.q5;
  var equals = kotlin_kotlin.$_$.k5;
  var Defaults_getInstance = kotlin_com_zegreatrob_tools_digger_core.$_$.a;
  //endregion
  //region block: pre-declaration
  setMetadataFor(ChangeType, 'ChangeType', classMeta, Enum);
  setMetadataFor(ChangeType$Major, 'Major', classMeta, ChangeType);
  setMetadataFor(ChangeType$Minor, 'Minor', classMeta, ChangeType);
  setMetadataFor(ChangeType$Patch, 'Patch', classMeta, ChangeType);
  setMetadataFor(ChangeType$None, 'None', classMeta, ChangeType);
  setMetadataFor(TagResult, 'TagResult', classMeta);
  setMetadataFor(Success, 'Success', objectMeta, TagResult);
  setMetadataFor(Error_0, 'Error', classMeta, TagResult);
  setMetadataFor(TaggerCore, 'TaggerCore', classMeta);
  setMetadataFor(Defaults, 'Defaults', objectMeta);
  setMetadataFor(Companion, 'Companion', objectMeta);
  setMetadataFor(VersionRegex, 'VersionRegex', classMeta);
  //endregion
  function asSemverComponents(_this__u8e3s4) {
    // Inline function 'kotlin.collections.map' call
    var this_0 = split(stripPrefix(_this__u8e3s4), ['.']);
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var item = tmp0_iterator.u();
      var tmp$ret$0 = toInt(item);
      destination.o(tmp$ret$0);
    }
    return destination;
  }
  function stripPrefix(_this__u8e3s4) {
    var tmp$ret$1;
    $l$block: {
      // Inline function 'kotlin.text.indexOfFirst' call
      var inductionVariable = 0;
      var last = charSequenceLength(_this__u8e3s4) - 1 | 0;
      if (inductionVariable <= last)
        do {
          var index = inductionVariable;
          inductionVariable = inductionVariable + 1 | 0;
          // Inline function 'com.zegreatrob.tools.tagger.core.stripPrefix.<anonymous>' call
          var it = charSequenceGet(_this__u8e3s4, index);
          if (!(digitToIntOrNull(it) == null)) {
            tmp$ret$1 = index;
            break $l$block;
          }
        }
         while (inductionVariable <= last);
      tmp$ret$1 = -1;
    }
    var startIndex = tmp$ret$1;
    // Inline function 'kotlin.text.substring' call
    // Inline function 'kotlin.js.asDynamic' call
    return _this__u8e3s4.substring(startIndex);
  }
  function calculateNextVersion(_this__u8e3s4, implicitPatch, versionRegex, releaseBranch) {
    var tmp0_elvis_lhs = lastVersionAndTag(_this__u8e3s4);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return '0.0.0';
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var tmp1_container = tmp;
    var previousVersionNumber = tmp1_container.o6();
    var lastTagDescription = tmp1_container.p6();
    var incrementComponent = findAppropriateIncrement(_this__u8e3s4.bu_1, lastTagDescription, implicitPatch, versionRegex);
    var tmp3_elvis_lhs = incrementComponent == null ? null : incrementComponent.fu(asSemverComponents(previousVersionNumber));
    var currentVersionNumber = tmp3_elvis_lhs == null ? previousVersionNumber : tmp3_elvis_lhs;
    var tmp_0;
    if (canRelease(_this__u8e3s4.bu_1.ot(), releaseBranch) ? !(currentVersionNumber === previousVersionNumber) : false) {
      tmp_0 = currentVersionNumber;
    } else {
      tmp_0 = currentVersionNumber + '-SNAPSHOT';
    }
    return tmp_0;
  }
  function ChangeType$Major() {
    ChangeType.call(this, 'Major', 0, 3);
    ChangeType_Major_instance = this;
  }
  protoOf(ChangeType$Major).fu = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    return '' + (major + 1 | 0) + '.0.0';
  };
  var ChangeType_Major_instance;
  function ChangeType$Minor() {
    ChangeType.call(this, 'Minor', 1, 2);
    ChangeType_Minor_instance = this;
  }
  protoOf(ChangeType$Minor).fu = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.c1(1);
    return '' + major + '.' + (minor + 1 | 0) + '.0';
  };
  var ChangeType_Minor_instance;
  function ChangeType$Patch() {
    ChangeType.call(this, 'Patch', 2, 1);
    ChangeType_Patch_instance = this;
  }
  protoOf(ChangeType$Patch).fu = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.c1(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.c1(2);
    return '' + major + '.' + minor + '.' + (patch + 1 | 0);
  };
  var ChangeType_Patch_instance;
  function ChangeType$None() {
    ChangeType.call(this, 'None', 3, 0);
    ChangeType_None_instance = this;
  }
  protoOf(ChangeType$None).fu = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.c1(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.c1(2);
    return '' + major + '.' + minor + '.' + patch;
  };
  var ChangeType_None_instance;
  var ChangeType_entriesInitialized;
  function ChangeType_initEntries() {
    if (ChangeType_entriesInitialized)
      return Unit_instance;
    ChangeType_entriesInitialized = true;
    ChangeType_Major_instance = new ChangeType$Major();
    ChangeType_Minor_instance = new ChangeType$Minor();
    ChangeType_Patch_instance = new ChangeType$Patch();
    ChangeType_None_instance = new ChangeType$None();
  }
  function ChangeType(name, ordinal, priority) {
    Enum.call(this, name, ordinal);
    this.eu_1 = priority;
  }
  function findAppropriateIncrement(gitAdapter, previousTag, implicitPatch, minorRegex) {
    // Inline function 'kotlin.collections.fold' call
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.also' call
    var this_0 = gitAdapter.nt('HEAD', '^' + previousTag);
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
    if (this_0.y())
      return null;
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var item = tmp0_iterator.u();
      // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
      var tmp0_elvis_lhs = changeType(item, minorRegex);
      var tmp$ret$1 = tmp0_elvis_lhs == null ? implicitPatch ? ChangeType_Patch_getInstance() : null : tmp0_elvis_lhs;
      destination.o(tmp$ret$1);
    }
    var accumulator = null;
    var tmp0_iterator_0 = destination.r();
    while (tmp0_iterator_0.s()) {
      var element = tmp0_iterator_0.u();
      accumulator = highestPriority(accumulator, element);
    }
    var tmp0_elvis_lhs_0 = accumulator;
    return tmp0_elvis_lhs_0 == null ? implicitPatch ? ChangeType_Patch_getInstance() : ChangeType_None_getInstance() : tmp0_elvis_lhs_0;
  }
  function canRelease(_this__u8e3s4, releaseBranch) {
    return ((_this__u8e3s4.qt_1 ? _this__u8e3s4.rt_1 === 0 : false) ? _this__u8e3s4.st_1 === 0 : false) ? _this__u8e3s4.tt_1 === releaseBranch : false;
  }
  function highestPriority(left, right) {
    return left == null ? right : right == null ? left : left.eu_1 > right.eu_1 ? left : right;
  }
  function changeType(_this__u8e3s4, versionRegex) {
    // Inline function 'kotlin.text.trim' call
    var this_0 = _this__u8e3s4.gt_1;
    var tmp$ret$0 = toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
    return changeType_0(versionRegex, tmp$ret$0);
  }
  function changeType_0(_this__u8e3s4, message) {
    var tmp;
    var tmp0_safe_receiver = _this__u8e3s4.wu_1;
    if ((tmp0_safe_receiver == null ? null : tmp0_safe_receiver.n8(message)) === true) {
      tmp = findMatchType(message, _this__u8e3s4.wu_1);
    } else {
      if (_this__u8e3s4.vu_1.n8(message)) {
        tmp = ChangeType_Major_getInstance();
      } else {
        if (_this__u8e3s4.uu_1.n8(message)) {
          tmp = ChangeType_Minor_getInstance();
        } else {
          if (_this__u8e3s4.tu_1.n8(message)) {
            tmp = ChangeType_Patch_getInstance();
          } else {
            if (_this__u8e3s4.su_1.n8(message)) {
              tmp = ChangeType_None_getInstance();
            } else {
              tmp = null;
            }
          }
        }
      }
    }
    return tmp;
  }
  function findMatchType(message, regex) {
    var tmp0_safe_receiver = regex.r8(message);
    var groups = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.i9();
    return groupExists(groups, 'major') ? ChangeType_Major_getInstance() : groupExists(groups, 'minor') ? ChangeType_Minor_getInstance() : groupExists(groups, 'patch') ? ChangeType_Patch_getInstance() : groupExists(groups, 'none') ? ChangeType_None_getInstance() : null;
  }
  function groupExists(_this__u8e3s4, groupName) {
    var tmp$ret$4;
    $l$block: {
      // Inline function 'kotlin.getOrDefault' call
      // Inline function 'kotlin.runCatching' call
      var tmp;
      try {
        // Inline function 'kotlin.Companion.success' call
        // Inline function 'com.zegreatrob.tools.tagger.core.groupExists.<anonymous>' call
        var value = !((_this__u8e3s4 == null ? null : get(_this__u8e3s4, groupName)) == null);
        tmp = _Result___init__impl__xyqfz8(value);
      } catch ($p) {
        var tmp_0;
        if ($p instanceof Error) {
          var e = $p;
          // Inline function 'kotlin.Companion.failure' call
          tmp_0 = _Result___init__impl__xyqfz8(createFailure(e));
        } else {
          throw $p;
        }
        tmp = tmp_0;
      }
      var this_0 = tmp;
      if (_Result___get_isFailure__impl__jpiriv(this_0)) {
        tmp$ret$4 = false;
        break $l$block;
      }
      var tmp_1 = _Result___get_value__impl__bjfvqg(this_0);
      tmp$ret$4 = (tmp_1 == null ? true : !(tmp_1 == null)) ? tmp_1 : THROW_CCE();
    }
    return tmp$ret$4;
  }
  function ChangeType_Major_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Major_instance;
  }
  function ChangeType_Minor_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Minor_instance;
  }
  function ChangeType_Patch_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Patch_instance;
  }
  function ChangeType_None_getInstance() {
    ChangeType_initEntries();
    return ChangeType_None_instance;
  }
  function lastVersionAndTag(_this__u8e3s4) {
    var tmp0_elvis_lhs = _this__u8e3s4.bu_1.pt(0);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return null;
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var description = tmp;
    var tmp_0;
    if (contains(description, '-')) {
      tmp_0 = substringBefore(description, '-');
    } else {
      tmp_0 = description;
    }
    var previousVersionNumber = tmp_0;
    // Inline function 'kotlin.text.ifEmpty' call
    var tmp_1;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(previousVersionNumber) === 0) {
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_1 = null;
    } else {
      tmp_1 = previousVersionNumber;
    }
    var tmp1_safe_receiver = tmp_1;
    var tmp_2;
    if (tmp1_safe_receiver == null) {
      tmp_2 = null;
    } else {
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_2 = to(tmp1_safe_receiver, description);
    }
    return tmp_2;
  }
  function tag(_this__u8e3s4, version, releaseBranch) {
    var isSnapshot_0 = isSnapshot(version);
    var headTag = _this__u8e3s4.bu_1.mt('HEAD');
    var alreadyTagged = !(headTag == null);
    var headBranch = _this__u8e3s4.bu_1.ot().tt_1;
    var isNotOnReleaseBranch = !(headBranch === releaseBranch);
    var tmp;
    if ((isSnapshot_0 ? true : alreadyTagged) ? true : isNotOnReleaseBranch) {
      // Inline function 'kotlin.collections.filterKeys' call
      var this_0 = mapOf([to(isSnapshot_0, 'being snapshot'), to(alreadyTagged, 'already tagged ' + headTag), to(isNotOnReleaseBranch, 'not on release branch ' + releaseBranch + ' - branch was ' + headBranch)]);
      var result = LinkedHashMap_init_$Create$();
      // Inline function 'kotlin.collections.iterator' call
      var tmp0_iterator = this_0.n2().r();
      while (tmp0_iterator.s()) {
        var entry = tmp0_iterator.u();
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        if (entry.o2()) {
          result.l2(entry.o2(), entry.p2());
        }
      }
      tmp = new Error_0('skipping tag due to ' + joinToString(result.k2(), ', '));
    } else {
      _this__u8e3s4.bu_1.kt(version, 'HEAD');
      _this__u8e3s4.bu_1.lt();
      tmp = Success_getInstance();
    }
    return tmp;
  }
  function isSnapshot(_this__u8e3s4) {
    return contains(_this__u8e3s4, 'SNAPSHOT');
  }
  function Success() {
    Success_instance = this;
    TagResult.call(this);
  }
  protoOf(Success).toString = function () {
    return 'Success';
  };
  protoOf(Success).hashCode = function () {
    return -888110432;
  };
  protoOf(Success).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Success))
      return false;
    other instanceof Success || THROW_CCE();
    return true;
  };
  var Success_instance;
  function Success_getInstance() {
    if (Success_instance == null)
      new Success();
    return Success_instance;
  }
  function Error_0(message) {
    TagResult.call(this);
    this.xu_1 = message;
  }
  protoOf(Error_0).toString = function () {
    return 'Error(message=' + this.xu_1 + ')';
  };
  protoOf(Error_0).hashCode = function () {
    return getStringHashCode(this.xu_1);
  };
  protoOf(Error_0).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Error_0))
      return false;
    var tmp0_other_with_cast = other instanceof Error_0 ? other : THROW_CCE();
    if (!(this.xu_1 === tmp0_other_with_cast.xu_1))
      return false;
    return true;
  };
  function TagResult() {
  }
  function TaggerCore(adapter) {
    this.bu_1 = adapter;
  }
  protoOf(TaggerCore).toString = function () {
    return 'TaggerCore(adapter=' + this.bu_1 + ')';
  };
  protoOf(TaggerCore).hashCode = function () {
    return hashCode(this.bu_1);
  };
  protoOf(TaggerCore).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TaggerCore))
      return false;
    var tmp0_other_with_cast = other instanceof TaggerCore ? other : THROW_CCE();
    if (!equals(this.bu_1, tmp0_other_with_cast.bu_1))
      return false;
    return true;
  };
  function Defaults() {
    Defaults_instance = this;
    this.yu_1 = Defaults_getInstance().yt_1;
    this.zu_1 = Defaults_getInstance().xt_1;
    this.av_1 = Defaults_getInstance().wt_1;
    this.bv_1 = Defaults_getInstance().vt_1;
  }
  var Defaults_instance;
  function Defaults_getInstance_0() {
    if (Defaults_instance == null)
      new Defaults();
    return Defaults_instance;
  }
  function Companion() {
    this.cv_1 = "version regex must include groups named 'major', 'minor', 'patch', and 'none'.";
  }
  protoOf(Companion).dv = function (regexPattern) {
    return ((contains(regexPattern, '?<major>') ? contains(regexPattern, '?<minor>') : false) ? contains(regexPattern, '?<patch>') : false) ? contains(regexPattern, '?<none>') : false;
  };
  var Companion_instance_0;
  function Companion_getInstance() {
    return Companion_instance_0;
  }
  function VersionRegex(none, patch, minor, major, unified) {
    this.su_1 = none;
    this.tu_1 = patch;
    this.uu_1 = minor;
    this.vu_1 = major;
    this.wu_1 = unified;
  }
  protoOf(VersionRegex).toString = function () {
    return 'VersionRegex(none=' + this.su_1 + ', patch=' + this.tu_1 + ', minor=' + this.uu_1 + ', major=' + this.vu_1 + ', unified=' + this.wu_1 + ')';
  };
  protoOf(VersionRegex).hashCode = function () {
    var result = hashCode(this.su_1);
    result = imul(result, 31) + hashCode(this.tu_1) | 0;
    result = imul(result, 31) + hashCode(this.uu_1) | 0;
    result = imul(result, 31) + hashCode(this.vu_1) | 0;
    result = imul(result, 31) + (this.wu_1 == null ? 0 : hashCode(this.wu_1)) | 0;
    return result;
  };
  protoOf(VersionRegex).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof VersionRegex))
      return false;
    var tmp0_other_with_cast = other instanceof VersionRegex ? other : THROW_CCE();
    if (!equals(this.su_1, tmp0_other_with_cast.su_1))
      return false;
    if (!equals(this.tu_1, tmp0_other_with_cast.tu_1))
      return false;
    if (!equals(this.uu_1, tmp0_other_with_cast.uu_1))
      return false;
    if (!equals(this.vu_1, tmp0_other_with_cast.vu_1))
      return false;
    if (!equals(this.wu_1, tmp0_other_with_cast.wu_1))
      return false;
    return true;
  };
  //region block: init
  Companion_instance_0 = new Companion();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = TaggerCore;
  _.$_$.b = VersionRegex;
  _.$_$.c = calculateNextVersion;
  _.$_$.d = tag;
  _.$_$.e = Companion_instance_0;
  _.$_$.f = Defaults_getInstance_0;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./tools-digger-core.js')));

//# sourceMappingURL=tools-tagger-core.js.map
